#include "Rainbow.h"
#include <avr/pgmspace.h>

/* ------------------------ seeedstudio driver code starts here -----------------------------------------*/
// Driver code from http://www.seeedstudio.com/depot/images/product/RaibowduinoCMD_Bata.rar
//=============================================================
extern unsigned char dots_color[2][3][8][4];  //define Two Buffs (one for Display ,the other for receive data)
extern unsigned char GamaTab[16];             //define the Gamma value for correct the different LED matrix
extern unsigned char Prefabnicatel[5][3][8][4];
extern unsigned char ASCII_Char[52][8];
extern unsigned char ASCII_Number[10][8];
//=============================================================
unsigned char line,level;
unsigned char Buffprt=0;
unsigned char State=0;
unsigned char g8Flag1;
unsigned char RainbowCMD[5]={0,0,0,0,0};

ISR(TIMER2_OVF_vect)          //Timer2  Service 
{ 
  TCNT2 = GamaTab[level];    // Reset a  scanning time by gamma value table
  flash_next_line(line,level);  // sacan the next line in LED matrix level by level.
  line++;
  if(line>7)        // when have scaned all LEC the back to line 0 and add the level
  {
    line=0;
    level++;
    if(level>15)       level=0;
  }
}

void init_timer2(void)               
{
  TCCR2A |= (1 << WGM21) | (1 << WGM20);   //  Fast PWM mode??
  TCCR2B |= (1<<CS22);   // by clk/64
  TCCR2B &= ~((1<<CS21) | (1<<CS20));   // by clk/64
  TCCR2B &= ~((1<<WGM21) | (1<<WGM20));   // Use normal mode
  ASSR |= (0<<AS2);       // Use internal clock - external clock not used in Arduino
  TIMSK2 |= (1<<TOIE2) | (0<<OCIE2B);   //Timer2 Overflow Interrupt Enable
  TCNT2 = GamaTab[0];
  sei();   
}

void _init(void)    // define the pin mode
{
	//  All ports for output
  DDRD=0xff;
  DDRC=0xff;
  DDRB=0xff;
  //  output port values set to 0
  PORTD=0;
  PORTB=0;
  /*
  Wire.begin(4); // join i2c bus (address optional for master) 
  Wire.onReceive(receiveEvent); // define the receive function for receiving data from master
  Wire.onRequest(requestEvent); // define the request function for the request from maseter 
  */
  init_timer2();  // initial the timer for scanning the LED matrix
}

/*

void receiveEvent(int howMany)
{
  unsigned char i=0;
  while(Wire.available()>0)
  { 

    RainbowCMD[i]=Wire.receive();
    i++;
  }

  if((i==5)&&(RainbowCMD[0]=='R')) State=processing;
  else      State=waitingcmd;	

}

void requestEvent(void)
{

  Wire.send(State); 
  if ((State==processing)||(State==checking))  SetRequest;

}

*/



void DispshowPicture(void)
{
   unsigned char pi,shifts;
   unsigned char color=0,row=0,dots=0;
   unsigned char temp;
   unsigned char fir,sec;

   shifts=((RainbowCMD[2]>>4)&0x0F);
   pi=RainbowCMD[4];
   RainbowCMD[1]=0;
   
  for(color=0;color<3;color++)
  {
    for (row=0;row<8;row++)
    {
      for (dots=0;dots<4;dots++)
      {

        if (shifts&0x01)
        {             
          temp = dots + (shifts>>1);
	   fir=pgm_read_byte(&(Prefabnicatel[pi][color][row][(temp<4)?(temp):(temp-4)]));
	   sec=pgm_read_byte(&(Prefabnicatel[pi][color][row][(temp<3)?(temp+1):(temp-3)]));
          dots_color[((Buffprt+1)&1)][color][row][dots] = (fir<<4)|(sec>>4);  
        }        
        else
        {
          temp = dots + (shifts>>1);
         dots_color[((Buffprt+1)&1)][color][row][dots] = pgm_read_byte(&(Prefabnicatel[pi][color][row][(temp<4)?(temp):(temp-4)]));  
         // Serial.print(pgm_read_byte(&(Prefabnicatel[pi][color][row][(temp<4)?(temp):(temp-4)])), HEX);
         // Serial.print(",");
        }
      }
    }
    // Serial.println("");
  }
  Buffprt++;
  Buffprt&=1;

}

void DispshowChar(void)
{
  unsigned char Col_Red,Col_Blue,Col_Green,shift,ASCII;
  unsigned char tempword,color,row,dots,Num,tempdata,tempcol,AS;
  
  // direction to shift character in, 0=no shift, 1-6 = shift left, 9-15 = shift right
  shift=((RainbowCMD[2]>>4)&0x0F);
  // 4 bits of intensity for each colour
  Col_Red=(RainbowCMD[2]&0x0F);
  Col_Green=((RainbowCMD[3]>>4)&0x0F);
  Col_Blue=(RainbowCMD[3]&0x0F);
  // character to display
  ASCII=RainbowCMD[4];
  RainbowCMD[1]=0;



	// limit characters that will be displayed
    if((ASCII>64)&&(ASCII<91)) AS=ASCII-65; 
    else if((ASCII>96)&&(ASCII<123)) AS=ASCII-71;
    else if( (ASCII>='0')&&(ASCII<='9')) AS=ASCII-48;	
	
  for(color=0;color<3;color++)
  {
     if(color==0)        tempcol=Col_Green;
    else if(color==1)   tempcol=Col_Red;
    else if(color==2)   tempcol=Col_Blue;

    for (row=0;row<8;row++)
    {  
    	// Get dots for the row, one bit per dot
      if( (ASCII>='0')&&(ASCII<='9'))
       tempword=pgm_read_byte(&(ASCII_Number[AS][row]));	
      else
      tempword=pgm_read_byte(&(ASCII_Char[AS][row]));

			// shift value < 7 is a left shift, > 7 is a right shift
			// is this a bug? if the value is 7 it will shift -1!
      tempword=(shift<7)?(tempword<<shift):(tempword>>(shift-8));	 

      for (dots=0;dots<4;dots++)
      {

				// pack two pixels of the character into the dots byte which contains 
				// four bits of intensity for each pixel
        if((tempword<<(2*dots))&0x80)		// if this pixel is set
        {
          tempdata&=0x0F;								// blank out the top four bits
          tempdata|=(tempcol<<4);				// put the intensity in the top four bits
        }
        else
        {
          tempdata&=0x0F;								// pixel not set, just blank out the top four bits
        }

        if((tempword<<(2*dots+1))&0x80)	// same for next pixel and bottom four bits
        {
          tempdata&=0xF0;
          tempdata|=tempcol;
        }
        else
        {
          tempdata&=0xF0;
        }   

				// dot goes into the buffer that is not currently being displayed:
				// if Buffprt=0 goes into buffer 1, if Buffprt=1 goes into buffer 0
        dots_color[((Buffprt+1)&1)][color][row][dots]=tempdata;	  


      }
    }
  }
  // Go to the next buffer to display what we just put in
  // bug: buffer is pointing outside array until the &=1, why not Buffprt = (Buffprt == 0 ? 1 : 0)
  Buffprt++;
  Buffprt&=1;
  
}

// Set all LEDs to all pixels on at the specified intensity for each colour
void DispshowColor(void)
{   
  unsigned char color=0,row=0,dots=0;
  unsigned char Gr,Bl,Re;

  // Bug: These seem to be mislabelled as they don't match the markings on the PCB
  // Colors in DispShowChar work correctly
  Re=(RainbowCMD[2]&0x0F);    // matches "Blue" on PCB
  Gr=((RainbowCMD[3]>>4)&0x0F); // = green, correct
  Bl=(RainbowCMD[3]&0x0F); // matches "Red" on the PCB
  RainbowCMD[1]=0;
  
  for(color=0;color<3;color++)
  {
    for (row=0;row<8;row++)
    {
      for (dots=0;dots<4;dots++)
      {
        switch (color)
        {
        case 0://green
          dots_color[((Buffprt+1)&1)][color][row][dots]=( Gr|(Gr<<4));
          break;

        case 1://blue
          dots_color[((Buffprt+1)&1)][color][row][dots]= (Bl|(Bl<<4));
          break;

        case 2://red
          dots_color[((Buffprt+1)&1)][color][row][dots]= (Re|(Re<<4));
          break;

        default:
          break;
        }
      }
    }
  }
  Buffprt++;
  Buffprt&=1;
}


void GetCMD(void)
{
  switch(RainbowCMD[1])
  	{
  	   case showPrefabnicatel:
	   DispshowPicture();	
	   break;

	   case showChar:
	   DispshowChar();	
	   break;

	   case showColor:
	   DispshowColor();	
	   break;
	   
  	}

}



//==============================================================
void shift_1_bit(unsigned char LS)  //shift 1 bit of  1 Byte color data into Shift register by clock
{
	//  Data to SDI port
  if(LS)
  {
    shift_data_1;
  }
  else
  {
    shift_data_0;
  }
  clk_rising; //  clock port down, then up, to shift data into register
}
//==============================================================
void flash_next_line(unsigned char line,unsigned char level) // scan one line
{
  disable_oe;			//  MBI5168 disable output
  close_all_line; //  all anodes down
  open_line(line); //  anode for this line up
  shift_24_bit(line,level); 
  enable_oe; //  MBI5168 enable output
}

//==============================================================
void shift_24_bit(unsigned char line,unsigned char level)   // display one line by the color level in buff
{
  unsigned char color=0,row=0;
  unsigned char data0=0,data1=0;
  le_high;	//  Latch enable input
  for(color=0;color<3;color++)//GBR
  {
    for(row=0;row<4;row++)
    {
      data1=dots_color[Buffprt][color][line][row]&0x0f;
      data0=dots_color[Buffprt][color][line][row]>>4;

      if(data0>level)   //gray scale,0x0f aways light
      {
        shift_1_bit(1);
      }
      else
      {
        shift_1_bit(0);
      }

      if(data1>level)
      {
        shift_1_bit(1);
      }
      else
      {
        shift_1_bit(0);
      }
    }
  }
  le_low;	//  Latch disable input
}



//==============================================================
void open_line(unsigned char line)     // open the scaning line 
{
  switch(line)
  {
  case 0:
    {
      open_line0;
      break;
    }
  case 1:
    {
      open_line1;
      break;
    }
  case 2:
    {
      open_line2;
      break;
    }
  case 3:
    {
      open_line3;
      break;
    }
  case 4:
    {
      open_line4;
      break;
    }
  case 5:
    {
      open_line5;
      break;
    }
  case 6:
    {
      open_line6;
      break;
    }
  case 7:
    {
      open_line7;
      break;
    }
  }
}



/* ------------------------ seeedstudio driver code ends here -----------------------------------------*/

/* ------------------------ our code starts here -----------------------------------------*/
void setup()
{
  Serial.begin(38400);
 _init();    // set up seeedstudio driver code 
 fridgeLightOn(4);  // turn on the "fridge light" at a low level
}

//==============================================================
/* Main Arduino loop, gets called over and over when the program is running */
boolean started = false;            // set to True when our dance routine has started
unsigned long startTime = 0;        // the time our dance routine started
boolean binarySoloDone = false;     // set to True when the binary solo has been done
boolean finallyRoboticBeingsDone = false;     // set to True when it has been done
void loop()
{
  if (!started) {
    checkForStartSignal();  // sets started flag and startTime time
    if (started) {
      fridgeLightOn(15);    // so I can see that I've pressed the button
    }
  }

  if (started) {
    // if it's time for the lipsinking on and we haven't done it yet
    if (!finallyRoboticBeingsDone && millis()-startTime >= 16500) {
      finallyRoboticBeings();
      turnFaceOn();
    // so it only does this once
      finallyRoboticBeingsDone = true;
    }
    
    // if it's time for 
  //the binary solo (and roboboogie) and we haven't done it yet
    if (!binarySoloDone && millis()-startTime >= 73500) {
      binarySolo();
      // wait for the right time to start roboboogie
      while (millis()-startTime < 87000) {
      }
      boogie();
      finalFace();
      // so it only does the solo once
      binarySoloDone = true;
    }      
  }
}

//==============================================================
// Show a character on the green and red LEDs (matrix and face) using the Rainbowduino driver code
void showGreenAndRedChar(char c) {
      RainbowCMD[1] = showChar;
      RainbowCMD[2] = 0; // shift
      RainbowCMD[2] = 0xf; // Red intensity
      RainbowCMD[3] = 0xf0; // Green & Blue intensity
      RainbowCMD[4] = c;  // character to display
      GetCMD();  // process the command
}

//==============================================================
// Show a character on the "red" LEDs (face) using the Rainbowduino driver code
void showRedChar(char c) {
      RainbowCMD[1] = showChar;
      RainbowCMD[2] = 0; // shift
      RainbowCMD[2] = 0xf; // Red intensity
      RainbowCMD[3] = 0; // Green & Blue intensity
      RainbowCMD[4] = c;  // character to display
      GetCMD();  // process the command
}

//==============================================================
// turn on all LEDs with brightness (0-15) set for each colour
void showColourRGB(byte red, byte green, byte blue) {
    RainbowCMD[1] = showColor;
    RainbowCMD[2] = blue; // Blue intensity
    RainbowCMD[3] = (green<<4) | red; // Green & Red intensity
    GetCMD();  // process the command
}


//==============================================================
  // This is a two-dimensional array (table). One entry per digit in the solo
  // Each entry contains the number to display and the time in millisecons from start of solo
  // binaries[n][0] is the digit, binaries[n][1] is the time
  // We are running out of memory so using PROGMEM http://www.arduino.cc/en/Reference/PROGMEM
  // 
 const prog_uint16_t binaries[56][2]  PROGMEM = {
    {0,0},
    {0,230},
    {0,490},
    {0,700},
    {0,900},
    {0,1100},
    {1,1300},
    
    {0,1720},
    {0,2130},
    {0,2330},
    {0,2530},
    {0,2630},
    {0,2730},
    {1,2970},
    {1,3150},
    
    {0,3400},
    {0,3600},
    {0,3800},
    {0,4030},
    {0,4250},
    {1,4430},
    {1,4540},
    {1,4650},
    
    {0,5050},
    {0,5275},
    {0,5500},
    {0,5700},
    {1,5900},
    {1,6000},
    {1,6130},
    {1,6250},
    
    {0,6749},
    {0,6992},
    {0,7212},
    {0,7373},
    {0,7567},
    {0,7790},
    {1,8050},
    
    {0,8458},
    {0,8650},
    {0,8842},
    {0,9057},
    {0,9319},
    {0,9500},
    {1,9630},
    {1,9890},
    
    {0,10150},
    {0,10350},
    {0,10550},
    {0,10750},
    {0,11000},
    {0,11250},
    {1,11450},
    {1,11525},
    {1,11625},

    // Dummy entry sets when to turn off the last digit
    {0,11850} // 56 entries
 };    

// zerods and ones 
void binarySolo() {
    unsigned long startmillis = millis();
    // For each digit in the solo
    for (int digit=0; digit < 55; digit++) {

      // The time in the solo that it starts
      // use pgm_read_word_near because it's in PROGMEM! Confusing!! http://www.arduino.cc/cgi-bin/yabb2/YaBB.pl?num=1209549912/6
      // & means "address of"
      unsigned int ontimeSolo =  pgm_read_word_near(&binaries[digit][1]); 
      
      // work out when we should display it relative to the time the solo started
      unsigned long ontime = ontimeSolo+startmillis;

      // wait till it's time to display it
      while (millis() < ontime) {
      }

      // Display the right character
      char c;
      unsigned int thisDigit = pgm_read_word_near(&binaries[digit][0]);
      if (thisDigit == 0) { // == NOT = !
        c = '0';
      }
      else {
        c = '1';
      }
      showGreenAndRedChar(c);
    
      // Work out when to turn the character off by looking at the start time for the next character
      ontimeSolo =  pgm_read_word_near(&binaries[digit+1][1]);
      unsigned long nexttime = ontimeSolo+startmillis; // the "+1" means we need an extra dummy entry at the end of the solo
      // turn it off at half the time between the start of this character and the start of the next character
      unsigned long displaytime = nexttime - ontime;
      unsigned long offtime = ontime + (displaytime/2); 
      while (millis() < offtime) {
      }
      showGreenAndRedChar('z');// we redefined 'z' to blank
    }
}

//==============================================================
int NXTTouchpin = 6;    // select the input pin for the NXT touch sensor signal
// Set started flag and startTime if the NXT touch sensor is pressed
void checkForStartSignal() {
  int touchValue = analogRead(NXTTouchpin);
  if (touchValue>50) {
    started = true;
    startTime = millis();
    // ("Started");

    // Do a self-test if the button is held down for more than 3 seconds
    while(touchValue>50) {
      if ((millis() - startTime) > 3000) {
        selfTest();
        // get out of the loop
        break;
      }
      touchValue = analogRead(NXTTouchpin);
    }
    
  }
}

//==============================================================
// Turn on the "fridge light" inside the robot, brightness 0-15
void fridgeLightOn(byte level) {
  showColourRGB(0,0,level); // it's the only LED on the "Blue" outputs
}


//==============================================================
  // This is for finaly robotic beings rule the word
 int ruleTheWorld [13][3] = {
    {0,0},
    {1,240},
    {2,330},
    {1,680},
    {0,940},
    {1,1100},
    {1,1340},
    
    {2,1500},
    {1,1830},
    {2,1970},
    {0,2130},
    {1,2260},
    
    // Dummy entry sets when to turn off the last digit
    {0,3000} // 56 entries
 };    
 
// lipsync "finally robotic beings rule the world" 
void finallyRoboticBeings() {
    unsigned long startmillis = millis();
    // For each digit in the talking
    for (int digit=0; digit < 12; digit++) {

      // work out when we should display it
      unsigned long ontime = (ruleTheWorld[digit][1])+startmillis;

      // wait till it's time to display it
      while (millis() < ontime) {
      }

      // Display the right character
      char c;
      if (ruleTheWorld[digit][0] == 0) {
        c = '0';  // mouth 'O' shape
      }      
      if (ruleTheWorld[digit][0] == 1) {
        c = '1';  // mouth smiley shape
      }  if (ruleTheWorld[digit][0] == 2) {
        c = '2';  // mouth full on
      }
      
      showRedChar(c);
    
      // Work out when to turn the character off by looking at the start time for the next character
      unsigned long nexttime = (ruleTheWorld[digit+1][1])+startmillis; // the "+1" means we need an extra dummy entry at the end of the solo
      // turn it off at half the time between the start of this character and the start of the next character
      unsigned long displaytime = nexttime - ontime;
      unsigned long offtime = ontime + (displaytime/2); 
      while (millis() < offtime) {
      }
      showRedChar('y');// 'y' is just the eyes, no mouth
    }
}

//==============================================================
// Turn on the whole robot face, brightness 0-15
void faceOn(byte level) {
  showColourRGB(level,0,0); // face is on the "Red" outputs
}

//==============================================================
// turn smile on
void turnFaceOn() {
 showRedChar('1');
}

//==============================================================
// turn face on, then fade it out
void finalFace() {
  showColourRGB(15,15,0);
  // "Once again without emotion..."
  delay(4000);
  for (int level=9; level >=0; level--) {
    showColourRGB(level, level, 0);
    delay(250);
  }
}

//==============================================================
// Quickly run all the displays
void selfTest() {
  finallyRoboticBeings();
  turnFaceOn();
  binarySolo();
  boogie();
  showColourRGB(15,15,15);
  finalFace();
  started = false;
  fridgeLightOn(1);
}

void showFrame(int frame) {
      RainbowCMD[1] = showPrefabnicatel;
      RainbowCMD[2] = 0; // shifts random(6)<<4; // 
      RainbowCMD[3] = 0; // unused?
      RainbowCMD[4] = frame;  // frame to display
      GetCMD();  // process the command
}

// show the random frames
void boogie() {
    unsigned long startTime = millis();
    while ((millis() - startTime) < 13000) {
      for (int frame=0; frame<5; frame++) {
          showFrame(frame);
          delay(250);
      } 
    }
}

